#	Smooth 	 Smooth with a Gaussian window along the first two axis
#	Smooth <In.h >Out.h
#
#	from par:	nwind1=1,nwind2=1,nwind5=1
#			gpow=1.
#			equal=no   >>	inmax!=outmax
#			edge=yes  
#			window1=gauss,(box)
#			window2=gauss,(box)
#			window5=gauss,(box)
#			half_window1=no,(casua,anticasual)
#
#	from history:	n1,n2,n3,n4,n5	
#
#	WARNING:	if nwind4 != 1 || nwind5 != 1 it does not
#			like pipes
#
#	source in /sep/biondo/Src/Smooth.rs
#%

character CHAR,new,equal*3,edge*3,window1*10,window2*10,window4*10,window5*10
character half_window1*10
integer nt,nx,nr,np,nq,nwind1,nwind2,nwind5,nwind4,nxall
integer esize,ntb,nxallb
real gpow


#character*(*) 	source
#character(128) 	source
#parameter (source='/homes/sep/biondo/Src/Smooth.rs')

from history:	integer esize=4
from history:	integer n1:nt,n2:nx=1,n3:np=1,n4:nq=1,n5:nr=1

from par:	character equal='no'//CHAR(0)
from par:	character edge='yes'//CHAR(0)
from par:	character window1='gauss'//CHAR(0)
from par:	character window2='gauss'//CHAR(0)
from par:	character window4='gauss'//CHAR(0)
from par:	character window5='gauss'//CHAR(0)
from par:	character half_window1='no'//CHAR(0)
from par:	integer nwind1=1,nwind2=1,nwind4=1,nwind5=1
from par:	real gpow=1.

if(mod(nwind1,2) == 0.)	call erexit('nwind1 must be odd')
if(mod(nwind2,2) == 0.)	call erexit('nwind2 must be odd')
if(mod(nwind4,2) == 0.)	call erexit('nwind4 must be odd')
if(mod(nwind5,2) == 0.)	call erexit('nwind5 must be odd')
if(equal(1:1) == 'y' && ((nwind4 != 1)||(nwind5 != 1)))	
	call erexit('')
if(edge(1:1) == 'y' && ((nwind4 != 1)||(nwind5 != 1)))	
	call erexit('')
if((nwind1 != 1 || nwind2 != 1) && nwind4 != 1)	
	call erexit('')
if((nwind1 != 1 || nwind2 != 1) && nwind5 != 1)	
	call erexit('')
if(nwind4 != 1 && nwind5 != 1)	
	call erexit('')

if(nwind4 != 1)	{
	nxall=nq
		}
else	{
	if(nwind5 != 1)	{
		nxall=nr
			}
	else	{
		nxall=nx
		}
	}
if(esize == 1)	{
	ntb=nt
	nxallb=nxall
		}
else	{
	ntb=1
	nxallb=1
	}

write(0,*)'nxall=',nxall
write(0,*)'nxallb=',nxallb
allocate:	integer inb(ntb,nxallb),outb(ntb,nxallb)
allocate:	real in(nt,nxall),out(nt,nxall)
allocate:	real wind1(nwind1),wind2(nwind2),wind4(nwind4),wind5(nwind5)
allocate:	real edg1(nwind1),edg2(nwind2),edg4(nwind4),edg5(nwind5)

subroutine Smooths(window1,window2,window4,window5,half_window1,
        edge,equal,esize,nt,nx,
	nxall,nr,np,nq,ntb,nxallb,nwind1,nwind2,nwind4,nwind5,gpow,inb,outb,
	in,out,wind1,wind2,wind4,wind5,edg1,edg2,edg4,edg5)
character equal*3,edge*3,window1*10,window2*10,window4*10,window5*10
character half_window1*10
integer input,output,infd,outfd
integer nt,nx,nxall,nr,np,nq,ir,ix,it,ip,iq
integer ntb,nxallb,esize
integer itin,ixin,irin,minit,minix,maxit,maxix,minir,maxir
integer iqin,miniq,maxiq
integer nwind1,nwind2,nwind4,nwind5,iwind1,iwind2,iwind4,iwind5
integer nw1d2,nw2d2,nw4d2,nw5d2,iw
integer ncube,offx,offp,offq

integer inb(ntb,nxallb),outb(ntb,nxallb)
real sum,gpow,smax,inmax,outmax,norm,w,half_scale
real in(nt,nxall),out(nt,nxall)
real wind1(nwind1),wind2(nwind2),wind4(nwind4),wind5(nwind5)
real edg1(nwind1),edg2(nwind2),edg4(nwind4),edg5(nwind5)


infd=input()
outfd=output()
call hclose ()

nw1d2=(nwind1-1)/2
nw2d2=(nwind2-1)/2
nw4d2=(nwind4-1)/2
nw5d2=(nwind5-1)/2

if(window1(1:1) == 'g')	{
	call gausw(nwind1,nw1d2+1,wind1)
			}
else	{
	if(window1(1:1) == 'b')	{
		call boxw(nwind1,nw1d2+1,wind1)
				}
	else	{
		call erexit('Window1 not implemented')
		}
	}
if(half_window1(1:1) == 'a'){
  do it=1,nw1d2 {
    wind1(it)=0.
  }
  half_scale=2./(wind1(nw1d2+1)+1.)
  do it=nw1d2+1,nwind1 {
    wind1(it)=half_scale*wind1(it)
  }
}
if(half_window1(1:1) == 'c'){
  do it=nw1d2+2,nwind1 {
     wind1(it)=0.
  }
  half_scale=2./(wind1(nw1d2+1)+1.)
  do it=1,nw1d2+1 {
    wind1(it)=half_scale*wind1(it)
  }
}
   

if(window2(1:1) == 'g')	{
	call gausw(nwind2,nw2d2+1,wind2)
			}
else	{
	if(window2(1:1) == 'b')	{
		call boxw(nwind2,nw2d2+1,wind2)
				}
	else	{
		call erexit('Window2 not implemented')
		}
	}
if(window4(1:1) == 'g')	{
	call gausw(nwind4,nw4d2+1,wind4)
			}
else	{
	if(window4(1:1) == 'b')	{
		call boxw(nwind4,nw4d2+1,wind4)
				}
	else	{
		call erexit('Window4 not implemented')
		}
	}
	
	
if(window5(1:1) == 'g')	{
	call gausw(nwind5,nw5d2+1,wind5)
			}
else	{
	if(window5(1:1) == 'b')	{
		call boxw(nwind5,nw5d2+1,wind5)
				}
	else	{
		call erexit('Window5 not implemented')
		}
	}
	
	
call snap('wind1.h',nwind1,1,wind1)
call snap('wind2.h',nwind2,1,wind2)
call snap('wind4.h',nwind4,1,wind4)
call snap('wind5.h',nwind5,1,wind5)

if(edge(1:1) == 'y')
{
do iwind1=1,nw1d2
	{
	sum=0.
	do iw=1,nw1d2-iwind1+1	{
		sum=sum+wind1(iw)
				}
	edg1(iwind1)=1./(1.-sum)
	}
do iwind2=1,nw2d2
	{
	sum=0.
	do iw=1,nw2d2-iwind2+1	{
		sum=sum+wind2(iw)
				}
	edg2(iwind2)=1./(1.-sum)
	}
do iwind4=1,nw4d2
	{
	sum=0.
	do iw=1,nw4d2-iwind4+1	{
		sum=sum+wind4(iw)
				}
	edg4(iwind4)=1./(1.-sum)
	}
do iwind5=1,nw5d2
	{
	sum=0.
	do iw=1,nw5d2-iwind5+1	{
		sum=sum+wind5(iw)
				}
	edg5(iwind5)=1./(1.-sum)
	}
}
	

if((nwind4 == 1)&&(nwind5 == 1))
{
	

do ir=1,nr	{
	do iq=1,nq	{
		do ip=1,np	{
	call zeror(nt*nx,out)
	if(esize == 1)	{
		call sreed("in",inb,nt*nx*1)
		call uncomp(nt*nx,inb,in)
			}
	else	{
		call sreed("in",in,nt*nx*4)
		}
	if(equal(1:1) == 'y')	{
		inmax=smax(nt*nx,in,1)
				}

	do iwind2=1,nwind2	{
		minix=max(1,nw2d2-iwind2+2)
		maxix=min(nx,nx-iwind2+nw2d2+1)
		do iwind1=1,nwind1	{
			minit=max(1,nw1d2-iwind1+2)
			maxit=min(nt,nt-iwind1+nw1d2+1)
			w=wind1(iwind1)*wind2(iwind2)
			do ix=minix,maxix	{
				ixin=ix+iwind2-nw2d2-1
				do it=minit,maxit	{
					itin=it+iwind1-nw1d2-1
	out(it,ix)=out(it,ix)+ w*in(itin,ixin)
							}
						}
					}
				}
	if(edge(1:1) == 'y')	
			{
#$dir scalar	
		do it=1,nw1d2	{
			w=edg1(it)
			do ix=1,nx	{
				out(it,ix)=w*out(it,ix)
					}
				}
#$dir scalar	
		do it=nt-nw1d2+1,nt	{
			w=edg1(nt-it+1)
			do ix=1,nx		{
				out(it,ix)=w*out(it,ix)
						}
					}
		do ix=1,nw2d2	{
			w=edg2(ix)
			do it=1,nt	{
				out(it,ix)=w*out(it,ix)
					}
				}
		do ix=nx-nw2d2+1,nx	{
			w=edg2(nx-ix+1)
			do it=1,nt	{
				out(it,ix)=w*out(it,ix)
					}
						}
			}
					
	if((equal(1:1) == 'y') && (outmax != 0))	
			{
		outmax=smax(nt*nx,out,1)
		norm=inmax/outmax
		do ix=1,nx	{
			do it=1,nt	{
				out(it,ix)=
				norm*out(it,ix)
					}
				}
			}
	if(esize == 1)	{
		call comp(nt*nx,out,outb)
		call srite("out",outb,nt*nx*1)
			}
	else	{
		call srite("out",out,nt*nx*4)
		}
				}
			}
		}
}
else
{
if(nwind5 != 1)
	{
	ncube=nt*nx*np*nq
	do iq=1,nq	{
		offq=(iq-1)*nt*nx*np
		do ip=1,np	{
			offp=(ip-1)*nt*nx+offq
			do ix=1,nx	{
	offx=(ix-1)*nt+offp
	call zeror(nt*nr,out)
	if(esize == 1)	{
		do ir=1,nr	{
			call sseek("in",1*(ncube*(ir-1)+offx),0)
			call sreed("in",inb(1,ir),nt*1)
				}
		call uncomp(nt*nr,inb,in)
			}
	else	{
		do ir=1,nr	{
			call sseek("in",4*(ncube*(ir-1)+offx),0)
			call sreed("in",in(1,ir),nt*4)
				}
		}
	
	do iwind5=1,nwind5	{
		minir=max(1,nw5d2-iwind5+2)
		maxir=min(nr,nr-iwind5+nw5d2+1)
		w=wind5(iwind5)
		do ir=minir,maxir	{
			irin=ir+iwind5-nw5d2-1
			do it=1,nt		{
				out(it,ir)=out(it,ir)+ w*in(it,irin)
						}
					}
				}
	if(esize == 1)	{
		call comp(nt*nr,out,outb)
		do ir=1,nr	{
			call sseek("out",1*(ncube*(ir-1)+offx),0)
			call srite("out",outb(1,ir),nt*1)
				}
			}
	else	{
		do ir=1,nr	{
			call sseek("out",4*(ncube*(ir-1)+offx),0)
			call srite("out",out(1,ir),nt*4)
				}
		}
	
					}
				}
			}
	}
else	{
	ncube=nt*nx*np
	do ir=1,nr	{
		do ip=1,np	{
			offp=(ip-1)*nt*nx
			do ix=1,nx	{
	offx=(ix-1)*nt+offp
	call zeror(nt*nq,out)
	if(esize == 1)	{
		do iq=1,nq	{
			call sseek("in",1*(ncube*(iq-1)+offx),0)
			call sreed("in",inb(1,iq),nt*1)
				}
		call uncomp(nt*nq,inb,in)
			}
	else	{
		do iq=1,nq	{
			call sseek("in",4*(ncube*(iq-1)+offx),0)
			call sreed("in",in(1,iq),nt*4)
				}
		}
	
	do iwind4=1,nwind4	{
		miniq=max(1,nw4d2-iwind4+2)
		maxiq=min(nq,nq-iwind4+nw4d2+1)
		w=wind4(iwind4)
		do iq=miniq,maxiq	{
			iqin=iq+iwind4-nw4d2-1
			do it=1,nt		{
				out(it,iq)=out(it,iq)+ w*in(it,iqin)
						}
					}
				}
	
	if(esize == 1)	{
		call comp(nt*nq,out,outb)
		do iq=1,nq	{
			call sseek("out",1*(ncube*(iq-1)+offx),0)
			call srite("out",outb(1,iq),nt*1)

				}
			}
	else	{
		do iq=1,nq	{
			call sseek("out",4*(ncube*(iq-1)+offx),0)
			call srite("out",out(1,iq),nt*4)
				}
		}
	
					}
				}
			}
	}
}

return;	end
