#<
#tau_z_convert
#
#Usage:
#call tau_z_convert (arg1, arg2 arg3)
#
#Input Parameters:
#
#
#Output Parameters:
#
#
#
#Description:
#
#
#
#>
#%end of self-documentaiton
#-------------------------------------------------
#
#Author: Bbo Clapp
#
#Date Created:Sun Nov 15 22:07:08 1998
#
#Purpose: 
#
#
module tau_z_convert_mod{ 
use axis_types_mod
integer, save,  private :: nvel(2)
real, save,  private :: ovel(2)
real, save,  private :: dvel(2)
real(kind=wp),save,private :: maxvel(2)

contains



subroutine init_tau_z_convert(n,o,d){
	integer :: n(2)
	real :: o(2),d(2)

	nvel=n
	ovel=o
	dvel=d

	maxvel=ovel+dvel*(nvel-1)


}

subroutine create_tau_map(vel,map){
real :: vel(:,:),map(:,:)
integer :: i1,i2
real :: time


do i2=1,nvel(2){
  map(1,i2)=0.
  time=2*dvel(2)/vel(1,i2)
  do i1=2,nvel(1){
    map(i1,i2)=time
    time+=2*dvel(2)/vel(i1,i2)
  }
}

}

subroutine convert_z_tau(x,z,n1,n2,map,vel){
real(kind=wp) :: x(:,:),z(:,:),fractx,fractz,tempr,temp2r,dd
real :: map(:,:),vel(:,:)
integer :: iz,ix,n1,n2,i1,i2

do i2=1,n2{
  do i1=1,n1{
    fractx=(x(i1,i2)-ovel(2))/dvel(2)
    fractz=(z(i1,i2)-ovel(1))/dvel(1)
    ix=floor(fractx); fractx-=ix
    iz=floor(fractz); fractz-=iz
    if(ix>0 && ix < nvel(2) && iz > 0 && iz < nvel(1)){
      z(i1,i2)=(1.-fractx)*(1.-fractz)*map(iz,ix)+
      (fractx)*(1.-fractz)*map(iz,ix+1)+
      (1.-fractx)*(fractz)*map(iz+1,ix)+
      (fractx)*(fractz)*map(iz+1,ix+1)
    }
    else{
      if(iz<=0) z(i1,i2)=0.
      else if(iz>=nvel(1)){
        if(ix<1){
          z(i1,i2)=map(nvel(1),1)+
            2*distance(maxvel(2),maxvel(1),x(i1,i2),z(i1,i2))/vel(nvel(1),1)
        }
        else if(ix>=nvel(2)){
          z(i1,i2)=map(nvel(1),nvel(2))+
            2*distance(maxvel(2),maxvel(1),x(i1,i2),z(i1,i2))/vel(nvel(1),nvel(2))
        }
        else{
          tempr=(1.-fractx)*vel(nvel(1),ix)+fractx*vel(nvel(1),ix+1)
          temp2r=(1.-fractx)*map(nvel(1),ix)+fractx*map(nvel(1),ix+1)
          z(i1,i2)=temp2r+2*(z(i1,i2)-maxvel(1))/tempr
        }
 }
      else{
        if(ix<1){
          tempr=(1.-fractz)*vel(iz,1)+fractz*vel(iz+1,1)
          temp2r=(1.-fractz)*map(iz,1)+fractz*map(iz+1,1)
          dd=ovel(2)-x(i1,i2)
        }
        else{
          tempr=(1.-fractz)*vel(iz,nvel(2))+fractz*vel(iz+1,nvel(2))
          temp2r=(1.-fractz)*map(iz,nvel(2))+fractz*map(iz+1,nvel(2))
          dd=x(i1,i2)-maxvel(2)

        }
        z(i1,i2)=temp2r+2*dd/tempr
      }
    }
  }
}
}



subroutine convert_vel_z_tau(map,vel_z,vel_tau,d){
real :: vel_z(:,:),vel_tau(:,:),map(:,:)
integer :: i1,i2,n1_in,n1_out,n2
real :: d,depth,fract
integer :: tempi,tb,ta,bi,ia

n1_in=nvel(1)
n1_out=size(vel_tau,1)
n2=nvel(2)


do i2=1,n2{
  fract=(map(1,i2)/d)+1.
  tb=floor(fract)
  do i1=1,tb{
    vel_tau(i1,i2)=vel_z(1,i2)
  }
  fract=(map(n1_in,i2)/d)+1.
  ta=ceiling(fract)


  if(ta <= n1_out){
    do i1=ta,n1_out{
      vel_tau(i1,i2)=vel_z(n1_in,i2)
    }
  }
  bi=1
  depth=(tb-1)*d
	if(ta>n1_out) vel_tau(n1_out,i2)=vel_z(n1_in,i2)
	tb=max(1,tb); ta=min(ta,n1_out)


  do i1=tb+1,ta-1{
		depth+=d
    if(map(bi,i2) > depth) call erexit("to small error")
    while(map(bi+1,i2) <= depth && bi<nvel(1)) bi+=1
    if(bi==nvel(1)) call erexit("big error")
    fract=(depth-map(bi,i2))/dvel(1)
    vel_tau(i1,i2)=(1.-fract)*vel_z(bi,i2)+fract*vel_z(bi+1,i2)
  }
}
}
subroutine create_z_map(vel,map){
real :: vel(:,:),map(:,:)
integer i1,i2
real :: depth


do i2=1,nvel(2){
  depth=0
    depth=dvel(1)*vel(1,i2)/2.
    map(1,i2)=0.
  do i1=2,nvel(1){
    map(i1,i2)=depth
    depth+=dvel(1)*vel(i1,i2)/2.
  }
}

}


real(kind=wp) function distance(s2_x,s2_z,q_x,q_z){
real(kind=wp) :: s2_x,s2_z,q_x,q_z

distance=(s2_x-q_x)**2+(s2_z-q_z)**2
}

subroutine calc_sigma(vel,sigma){
real :: vel(:,:),sigma(:,:)
integer i1,i2

sigma(:,1)=(vel(:,2)-vel(:,1))/dvel(2)
sigma(:,nvel(1))=(vel(:,nvel(2))-vel(:,nvel(2)-1))/dvel(2)
do i2=2,nvel(2)
  sigma(:,i2)=(vel(:,i2+1)-vel(:,i2-1))/dvel(2)

}



}
